[LeetCode] 1046. Last Stone Weight

We have a collection of stones, each stone has a positive integer weight.

Each turn, we choose the two heaviest stones and smash them together. Suppose the stones have weights x and y with x <= y. The result of this smash is:

If x == y, both stones are totally destroyed;
If x != y, the stone of weight x is totally destroyed, and the stone of weight y has new weight y-x.
At the end, there is at most 1 stone left. Return the weight of this stone (or 0 if there are no stones left.)

Example 1:

Input: [2,7,4,1,8,1]
Output: 1
Explanation: 
We combine 7 and 8 to get 1 so the array converts to [2,4,1,1,1] then,
we combine 2 and 4 to get 2 so the array converts to [2,1,1,1] then,
we combine 2 and 1 to get 1 so the array converts to [1,1,1] then,
we combine 1 and 1 to get 0 so the array converts to [1] then that's the value of last stone.

Note:

  1. 1 <= stones.length <= 30
  2. 1 <= stones[i] <= 1000

这道题因为每次都是取最重的两个,所以比较直观的想法就是要排序,那么用什么方法排序呢?因为我们要不停的做插入和删除,最好的就是priority queue,因为所有的操作都是O(logN)。 需要注意的是python的priority queue用heapq表示,但heapq是min queue,所以要转换成max queue的话要对成员内容取反。这道最终的时间复杂度是O(NlogN), 空间复杂度是O(N)。

import heapq
class Solution:
    def lastStoneWeight(self, stones: List[int]) -> int:
        if not stones: return 0
        
        heap = []
        for stone in stones:
            heappush(heap, -stone)
            
        while len(heap) >= 2:
            s1 = heappop(heap)
            s2 = heappop(heap)
            heappush(heap, s1-s2)
        
        if not heap: return 0
        return -heappop(heap)

猜你喜欢

转载自www.cnblogs.com/codingEskimo/p/12689133.html